############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub Common::NXTime::getSecondsSinceEpoch{package Common::NXTime;no warnings;(my $seconds
=libnxh::NXGetTime ());return ($seconds);}sub 
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch{package Common::NXTime;no 
warnings;(my $buffer=("\x3a" x (0x07aa+ 6019-0x1f05)));my (@arr);my (@result);(my $retval
=libnxh::NXSecondsAndMicrosecondsSinceEpoch ($buffer));if (($retval!=(-
(0x0f90+ 1592-0x15c7)))){(@arr=split ( /:/ ,$buffer,(0x07b9+ 2786-0x129b)));(
@result=splice (@arr,(0x0c68+ 5629-0x2265),(0x0f9c+ 864-0x12fa)));return (
@result);}else{(my $errorNumber=libnxh::NXGetError ());(my $errorString=
libnxh::NXGetErrorString ());syswrite (STDERR,
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x20\x77\x69\x74\x68\x20\x6d\x69\x63\x72\x6f\x73\x65\x63\x6f\x6e\x64\x20\x70\x72\x65\x63\x69\x73\x69\x6f\x6e\x2e\x0a"
);syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getMillisecondsSinceEpoch{package Common::NXTime;no warnings
;(my ($seconds,$microseconds)=getSecondsAndMicrosecondsSinceEpoch ());(my $milliseconds
=int ((($seconds *(0x1c63+ 1657-0x1ef4))+($microseconds/(0x0434+ 9828-0x26b0))))
);return ($milliseconds);}sub Common::NXTime::getLocalTime{package 
Common::NXTime;no warnings;my (@arr);my (@result);(my $buffer=("\x3a" x 
(0x0da6+ 3825-0x1c6f)));(my $retval=libnxh::NXLocalTime ($buffer));if (($retval
!=(-(0x0e79+ 4119-0x1e8f)))){(@arr=split ( /:/ ,$buffer,(0x00c0+ 7261-0x1d1d)));
(@result=splice (@arr,(0x19dc+ 1217-0x1e9d),(0x04d6+ 8044-0x2439)));return (
@result);}else{(my $errorNumber=libnxh::NXGetError ());(my $errorString=
libnxh::NXGetErrorString ());syswrite (STDERR,
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x2e\x0a"
);syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getLocalTimeFromTimestamp{package Common::NXTime;no warnings
;(my $stamp=shift (@_));my (@arr);my (@result);(my $buffer=("\x3a" x 
(0x1c4b+ 872-0x1f8b)));(my $retval=libnxh::NXLocalTimeFromTimestamp ($stamp,
$buffer));if (($retval!=(-(0x0410+ 3161-0x1068)))){(@arr=split ( /:/ ,$buffer,
(0x0447+ 2257-0x0d18)));(@result=splice (@arr,(0x0023+ 2878-0x0b61),
(0x0d83+ 4932-0x20be)));return (@result);}else{(my $errorNumber=
libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());syswrite (
STDERR,((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x2e\x20\x41\x72\x67\x75\x6d\x65\x6e\x74\x20\x69\x73\x20"
.$stamp)."\x2e\x0a"));syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getDateString{package Common::NXTime;no warnings;(my $string
=libnxh::NXLocalTimeAsString ());return ($string);}sub 
Common::NXTime::getTimestamp{package Common::NXTime;no warnings;(my ($sec,
$microsec)=getSecondsAndMicrosecondsSinceEpoch ());(my (@time)=
getLocalTimeFromTimestamp ($sec));(my $milisec=sprintf ("\x25\x30\x36\x64",
$microsec));($milisec=((substr ($milisec,(0x12d9+ 3781-0x219e),
(0x02c4+ 5314-0x1783))."\x2e").substr ($milisec,(0x1a0c+ 1972-0x21bd))));(my $Timestamp
=((((((sprintf ("\x25\x30\x32\x64",$time[(0x1525+ 1528-0x1b1b)])."\x3a").sprintf
 ("\x25\x30\x32\x64",$time[(0x0e13+ 710-0x10d8)]))."\x3a").sprintf (
"\x25\x30\x32\x64",$time[(0x1a91+  28-0x1aad)]))."\x3a").sprintf ($milisec)));
return ($Timestamp);}sub Common::NXTime::getTimestampOnlyMicroseconds{package 
Common::NXTime;no warnings;(my ($sec,$microsec)=
getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf ("\x25\x30\x36\x64"
,$microsec));($milisec=((substr ($milisec,(0x05f1+ 2806-0x10e7),
(0x0ced+ 469-0x0ebf))."\x2e").substr ($milisec,(0x1b39+ 2378-0x2480))));(my $Timestamp
=sprintf ($milisec));return ($Timestamp);}sub Common::NXTime::__getTimeMs{
package Common::NXTime;no warnings;(my ($sec,$microsec)=
getSecondsAndMicrosecondsSinceEpoch ());(my (@time)=getLocalTimeFromTimestamp (
$sec));(my $milisec=sprintf ("\x25\x30\x36\x64",$microsec));($milisec=(substr (
$milisec,(0x144f+ 1603-0x1a92),(0x0763+ 7988-0x2694)).substr ($milisec,
(0x04a1+ 3770-0x1358))));return ($milisec,@time);}sub Common::NXTime::getTimeMs{
package Common::NXTime;no warnings;(my ($milisec,@time)=__getTimeMs ());(my $TimeMs
=((((sprintf ("\x25\x30\x32\x64",$time[(0x1644+ 3511-0x23f9)]).sprintf (
"\x25\x30\x32\x64",$time[(0x1e0c+ 1990-0x25d1)])).sprintf ("\x25\x30\x32\x64",
$time[(0x197d+ 528-0x1b8d)]))."\x2e").sprintf ($milisec)));return ($TimeMs);}sub
 Common::NXTime::getLoggerTimeline{package Common::NXTime;no warnings;(my (
$milisec,@time)=__getTimeMs ());($milisec=((substr ($milisec,
(0x07fa+ 7559-0x2581),(0x02bc+ 4300-0x1385))."\x2e").substr ($milisec,
(0x0fa8+ 1700-0x1649))));(my $Timeline=(sprintf (
"\x25\x30\x34\x64\x2d\x25\x30\x32\x64\x2d\x25\x30\x32\x64\x20\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x20"
,(1900+$time[(0x09e2+ 5933-0x210a)]),((0x0a03+ 2048-0x1202)+$time[
(0x0175+ 7230-0x1daf)]),$time[(0x1726+ 1829-0x1e48)],$time[(0x00d2+ 2441-0x0a59)
],$time[(0x0621+ 2221-0x0ecd)],$time[(0x054d+ 7414-0x2243)]).$milisec));return (
$Timeline);}sub Common::NXTime::getLoggerTimelineOnlyMicroseconds{package 
Common::NXTime;no warnings;(my ($milisec,@time)=__getTimeMs ());($milisec=((
substr ($milisec,(0x10e7+ 4579-0x22ca),(0x020b+ 1646-0x0876))."\x2e").substr (
$milisec,(0x0b04+  77-0x0b4e))));(my $Timeline=sprintf ($milisec));return (
$Timeline);}sub 
Common::NXTime::convertLocalTimeFromTimestampToHumanReadableString{package 
Common::NXTime;no warnings;(my $timestamp=shift (@_));(my (@time)=
getLocalTimeFromTimestamp ($timestamp));(my $timeString=sprintf (
"\x25\x30\x34\x64\x2d\x25\x30\x32\x64\x2d\x25\x30\x32\x64\x20\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x3a\x25\x30\x32\x64"
,((0x1ff0+ 1759-0x1f63)+$time[(0x07ac+ 6887-0x228e)]),($time[
(0x0aed+ 5962-0x2233)]+(0x1402+ 709-0x16c6)),$time[(0x07b5+ 3725-0x163f)],$time[
(0x0b8c+ 5761-0x220b)],$time[(0x1932+ 1356-0x1e7d)],$time[(0x0651+ 2084-0x0e75)]
));return ($timeString);}sub Common::NXTime::getDateTimeForFileName{package 
Common::NXTime;no warnings;(my $dateTime=getLoggerTimeline ());($dateTime=~ s/ [^ ]*$// )
;($dateTime=~ s/-/./gm );($dateTime=~ s/:/./gm );($dateTime=~ s/ /-/gm );return 
($dateTime);}sub Common::NXTime::getSecondsInWeek{package Common::NXTime;no 
warnings;return (604800);}sub Common::NXTime::convertSecondsToDaysRounded{
package Common::NXTime;no warnings;(my $seconds=shift (@_));(my $days=($seconds/
86400));($days=(int ($days)+(0x0a84+ 3465-0x180c)));return ($days);}package 
Common::NXTime;no warnings;"\x3f\x3f\x3f";
